import * as i0 from '@angular/core';
import { signal, forwardRef, Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

class InputComponent {
    constructor() {
        this.disabled$ = signal(false);
        this.controlValue$ = signal(null);
    }
    set disabled(disabled) {
        this.disabled$.set(disabled);
    }
    inputChanged(event) {
        this.controlValue$.set(event);
        this.onChangeFn?.(event);
    }
    registerOnChange(onChangeFn) {
        this.onChangeFn = onChangeFn;
    }
    registerOnTouched(onTouchedFn) {
        this.onTouchedFn = onTouchedFn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(value) {
        if (typeof value !== 'string') {
            this.controlValue$.set(null);
            return;
        }
        this.controlValue$.set(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: InputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.0.8", type: InputComponent, selector: "input[sp-input], textarea[sp-textarea]", inputs: { disabled: "disabled" }, host: { listeners: { "input": "this.inputChanged($event?.target?.value)" }, properties: { "attr.disabled": "disabled$() || null", "value": "this.controlValue$()" }, classAttribute: "sp-input-text" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => InputComponent),
                multi: true
            }
        ], ngImport: i0, template: "", styles: [""], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: InputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'input[sp-input], textarea[sp-textarea]', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        'class': 'sp-input-text',
                        '[attr.disabled]': 'disabled$() || null',
                        '(input)': 'this.inputChanged($event?.target?.value)',
                        '[value]': 'this.controlValue$()'
                    }, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => InputComponent),
                            multi: true
                        }
                    ], template: "" }]
        }], propDecorators: { disabled: [{
                type: Input
            }] } });

class InputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: InputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.0.8", ngImport: i0, type: InputModule, declarations: [InputComponent], exports: [InputComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: InputModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: InputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        InputComponent
                    ],
                    imports: [],
                    exports: [
                        InputComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of input
 */

/**
 * Generated bundle index. Do not edit.
 */

export { InputComponent, InputModule };
//# sourceMappingURL=spicysources-input.mjs.map
